///
/// PWM
///
/// @author Sasaji
/// @date   2016.05.17
///

//
module MY_PWM1 (
	input wire clk,
	input wire res_n,
	input wire [7:0] in,
	output wire out
);
parameter cnt256_max = 255;

wire [7:0] cnt256;
MY_PWM_COUNTER #(cnt256_max) uMY_PWM_COUNTER (
	.clk		( clk ),
	.res_n	( res_n ),
	.count	( cnt256 )
);

//
reg pwmout;
always @(posedge clk, negedge res_n)
begin
	if (~res_n) begin
		pwmout <= 1'b0;
	end
	else begin
		pwmout <= (in != 4'h0 && in >= cnt256 ? 1'b1 : 1'b0); 
	end
end
//
assign out = pwmout;

endmodule

//
module MY_PWM_COUNTER
(
	input wire clk,
	input wire res_n,
	output wire [7:0] count
);
parameter cnt_max = 255;

reg [7:0] cnt;
//
always @(posedge clk, negedge res_n)
begin
	if (~res_n)
		cnt <= 6'h0;
	else if (cnt == cnt_max)
		cnt <= 6'h0;
	else 
		cnt <= cnt + 6'h1;
end
//
assign count = cnt;

endmodule
 